



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ReentrantLock重入锁详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ReentrantLock重入锁详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 21:34:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1.定义</strong></p>
<p>重入锁：能够支持一个线程对资源的重复加锁，也就是当一个线程获取到锁后，再次获取该锁时而不会被阻塞。</p>
<p><strong>2.可重入锁的应用场景</strong></p>
<p>2.1 如果已经加锁，则不再重复加锁，比如：交互界面点击后响应时间长，可能会多次点击，使用重入锁可防止后台重复执行。</p>
<div>
<pre class="prettyprint linenums">if (lock.tryLock()) {  //如果已经被lock，则立即返回false不会等待，达到忽略操作的效果<br />
    try {<br />
    //操作<br />
    } finally {<br />
      lock.unlock();<br />
    }<br />
}</pre>
</div>
<p>2.2 如果发现该操作已经在执行，则等待一段时间，超时则不再执行。</p>
<div>
<pre class="prettyprint linenums">try {<br />
    if (lock.tryLock(5, TimeUnit.SECONDS)) {  //如果已经被lock，尝试等待5s，看是否可以获得锁，如果5s后仍然无法获得锁则返回false继续执行<br />
        try {<br />
        //操作<br />
        } finally {<br />
          lock.unlock();<br />
        }<br />
     }<br />
} catch (InterruptedException e) {<br />
   e.printStackTrace(); //当前线程被中断时(interrupt)，会抛InterruptedException<br />
}</pre>
</div>
<p>2.3 如果操作已经加锁，则等待一个一个加锁。可以防止资源使用冲突，保证同一个时间内只有一个操作可以使用该资源。</p>
<div>
<pre class="prettyprint linenums">lock.lock(); //如果被其它资源锁定，会在此等待锁释放，也将处于阻塞状态</pre>
</div>
<p>2.4 可中断锁：可响应中断操作，然后释放锁。</p>
<div>
<pre class="prettyprint linenums">lock.lockInterruptibly();</pre>
</div>
<p><strong>3.原理分析</strong></p>
<p>可重入锁在获取锁时，有公平和非公平获取锁两种方式，默认是后者。如果在绝对时间上，先对锁进行获取的请求先被满足，那么这个锁则是公平锁，也就是等待时间最长的线程优先获取锁。反之，则是非公平锁，非公平锁的效率较高。我们知道ReentrantLock</p>
<p>是通过使用自定义同步器来实现锁的获取和释放的，那么就看一下获取同步状态的代码。</p>
<p><strong>3.1 非公平锁获取状态的代码</strong></p>
<div>
<pre class="prettyprint linenums"> final boolean nonfairTryAcquire(int acquires) {<br />
            final Thread current = Thread.currentThread();<br />
            int c = getState();<br />
            if (c == 0) {<br />
                if (compareAndSetState(0, acquires)) {<br />
                    setExclusiveOwnerThread(current);<br />
                    return true;<br />
                }<br />
            }<br />
            else if (current == getExclusiveOwnerThread()) {<br />
                int nextc = c + acquires;<br />
                if (nextc &lt; 0) // overflow<br />
                    throw new Error("Maximum lock count exceeded");<br />
                setState(nextc);<br />
                return true;<br />
            }<br />
            return false;<br />
        }</pre>
</div>
<p>以上代码逻辑是这样的：当一个线程尝试获取锁时，先判断同步状态值是否为0,如果是，则该现场获取到锁，并返回true；如果同步状态值不为0，则判断该线程是否就是占用该锁的当前线程，如果是，则同步状态值增加，表示同一个线程多次加锁，并返回ture。否则，则获取同步状态值失败，返回false。</p>
<p><strong>3.2 释放状态时的代码</strong></p>
<div>
<pre class="prettyprint linenums">        protected final boolean tryRelease(int releases) {<br />
            int c = getState() - releases;<br />
            if (Thread.currentThread() != getExclusiveOwnerThread())<br />
                throw new IllegalMonitorStateException();<br />
            boolean free = false;<br />
            if (c == 0) {<br />
                free = true;<br />
                setExclusiveOwnerThread(null);<br />
            }<br />
            setState(c);<br />
            return free;<br />
        }</pre>
</div>
<p>在释放锁时，每释放一次，同步状态值就是减少，最终同步状态值为0时，表示完全释放锁，此时将占有线程设置为null，同时返回true。</p>
<p><strong>3.3 公平锁获取状态时的代码</strong></p>
<div>
<pre class="prettyprint linenums">        /**<br />
         * Fair version of tryAcquire.  Don't grant access unless<br />
         * recursive call or no waiters or is first.<br />
         */<br />
        protected final boolean tryAcquire(int acquires) {<br />
            final Thread current = Thread.currentThread();<br />
            int c = getState();<br />
            if (c == 0) {<br />
                if (!hasQueuedPredecessors() &amp;&amp;<br />
                    compareAndSetState(0, acquires)) {<br />
                    setExclusiveOwnerThread(current);<br />
                    return true;<br />
                }<br />
            }<br />
            else if (current == getExclusiveOwnerThread()) {<br />
                int nextc = c + acquires;<br />
                if (nextc &lt; 0)<br />
                    throw new Error("Maximum lock count exceeded");<br />
                setState(nextc);<br />
                return true;<br />
            }<br />
            return false;<br />
        }<br />
    }</pre>
</div>
<p>这和nonfairTryAcquire方法唯一的区别就是增加了hasQueuedPredecessors()方法，该方法的作用就是判断同步队列中当前节点是否有前驱节点。如果该方法返回true，则表示有线程比当前线程更早地请求获取锁，因此需要等待前驱线程获取并释放锁之后才能</p>
<p>继续获取锁。</p>
<p>现在有个问题需要思考，为什么非公平锁效率更高？</p>
<p>在nonfairTryAcquire(int acquires)方法中，当一个线程请求锁时，只要获取了同步状态即成功获取锁。在这个前提下，刚释放锁的线程再次获取同步状态的几率会非常大，使得其他线程只能在同步队列中等待。它虽然造成了线程饥饿，但是确实极少的线程切换，</p>
<p>保证了更达的吞吐量。而公平性锁保证了锁的获取按照FIFO原则，而代价是进行大量的线程切换。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39rgv378.html">jquery&plus;bootstrap实现tab切换&comma; 每次切换时都请求数据&comma; 点击提交分别向不同的地址提交数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r7nne8.html">win7远程桌面恢复全屏状态快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o0gel8.html">build&period;xml详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw70ok8.html">C&num;winform中ListView及ContextMenuStrip的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0zlwlq.html">Digit &lpar;数位DP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zv1769.html">OpenGL Shader源码分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0okm4q.html">part3</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ky0p49.html">How many Knight Placing&quest;    UVA - 11091</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljdxz69.html">Web Api 接收图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eykoje9.html">MultiTigger 绑定异常处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z1ex39.html">多线程爬虫Miner</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz3o7l8.html">Ceph rdb</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25jr33q.html">MyBatis 一级缓存，二级缓存&comma;延迟加载设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5502eq.html">前端框架本质之探究&mdash;&mdash;以Vue&period;js为例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwkxny8.html">JavaSE&lowbar;坚持读源码&lowbar;HashMap对象&lowbar;put&lowbar;Java1&period;7</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyr3jgq.html">微信小程序 View：flex 布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ry4dz8.html">elasticsearch 使用快照进行备份</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd416z9.html">canvas的drawImage函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj2x7e9.html">SpringCloud报错： &amp;quot&semi;Field discoveryClient in com&period;controller&period;DcController required a bean of type &amp;&num;39&semi;com&period;netflix&period;discovery&period;DiscoveryClient&amp;&num;39&semi; that could not be found&period;&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpd0179.html">Passing the Message  单调栈两次</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kpyr279.html">使用Common&period;Logging&plus;log4net规范日志管理【转载】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzwg748.html">Web前端   页面功能&mdash;&mdash;点击按钮返回顶部的实现方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv16oroq.html">深海中的STL&mdash;mt19937</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2joex38.html">这个月干啥去了？&mdash;&mdash;H5&plus;移动应用实战开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z6vn19.html">AV-TEST杀毒软件能力测试（2018年1月-12月）杀毒软件排名</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2joe6l8.html">TLS &sol; SSL密码强化的建议</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zrvge9.html">JavaScript中的闭包和作用域链</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd04yk9.html">AngularJS学习之旅&mdash;AngularJS 过滤器&lpar;七&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pxrny8.html">JavaScript（二）数据类型（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljg4ee9.html">iOS 开发 nonatomic 和 atomic</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
